#ifndef _DLL_H_
#define _DLL_H_

#if BUILDING_DLL
# define DLLIMPORT __declspec (dllexport)
#else /* Not BUILDING_DLL */
# define DLLIMPORT __declspec (dllimport)
#endif /* Not BUILDING_DLL */

#ifdef _MSC_EXTENSIONS
#pragma pack(push)
#pragma pack(1)
#endif
typedef struct {
	int		numOfSongs;
	int		defSong; // zero based index (0....numOfSongs-1)
	char	*commentBuffer;
	int		currentTimeIn50Sec;
	bool    isStereo;
} sapMUSICstrc;
#ifdef _MSC_EXTENSIONS
#pragma pack(pop)
#endif

#define FCALL// __stdcall

extern "C"
DLLIMPORT sapMUSICstrc* FCALL sapLoadMusicFile( char *fname );
extern "C"
DLLIMPORT void FCALL sapPlaySong( int numOfSong );
extern "C"
DLLIMPORT void FCALL sapRenderBuffer( signed short *buffer, int number_of_samples );

// don't delete sapMUSICstrc returned via sapLoadMusicFile!!!
// don't modify or delete commentBuffer pointed by this structure!!!
// if error occurs, then sapLoadMusicFile returns NULL.
// sapRenderBuffer, fills given buffer with n=(number_of_samples) mono
// 8bit unsigned samples.
// example:
//
// sapMUSICstrc *currentFile;
// unsigned char playBuffer[44100];
// int currentSong;
//
// currentFile = sapLoadMusicFile( "music.sap" );
// currentSong = currentFile->defSong;
// again:
// while(key)
// {
//	sapRenderBuffer( &playBuffer, 44100 );
//	__play_buffer( );
// }
// if( key==next_song )
// {
//     currentSong = (currentSong+1) % currentFile->numOfSongs;
//     sapPlaySong( current_song );
//     goto again;
// }
// No data need to be deleted, bcoz SAP is using only static data
// and is able to play only one song at time

#endif /* _DLL_H_ */
