unit VarFloat;

interface

type
  Float = single;
const
  MinComp = -263E+1; { -9,223,372,036,854,775,808 }
  MaxComp =  263E-1; { +9,223,372,036,854,775,807 }

function SpecialFloat (Value: Float): boolean;

implementation

//returns true if s is Infinity, NAN or Indeterminate
//4byte IEEE: msb[31] = signbit, bits[23-30] exponent,
//bits[0..22] mantissa
//exponent of all 1s = Infinity, NAN or Indeterminate
function SpecialSingle (Value: Single): boolean;
  const
    kSpecialExponent = 255 shl 23;
  var
    Overlay: LongInt ABSOLUTE Value;
  begin
    if ((Overlay and kSpecialExponent) = kSpecialExponent) then
      RESULT := true
    else RESULT := false;
    end;

function SpecialFloat (Value: Float): boolean;
  begin
    Result := SpecialSingle (Value);
    end;

end.
 