{
}
unit sapH;

interface

const
  sapDLLNAME = 'sapDLL.dll';

type
  PsapMUSICstrc = ^TsapMUSICstrc;
  TsapMUSICstrc = record
       numOfSongs : integer;
       defSong : integer; // zero based index (0....numOfSongs-1)
       commentBuffer : PChar;
       currentTimeIn50Sec : integer;
       isStereo : Boolean;
  end;

   TsapLoadMusicFile = function (fileName : PChar ) : PsapMusicstrc;cdecl;
   TsapPlaySong      = function ( numOfSong : integer ):integer;cdecl;
   TsapRenderBuffer  = function ( buffer : PChar; number_of_samples:integer ):integer;cdecl;

var
  xsapLoadMusicFile : TsapLoadMusicFile;
  xsapPlaySong      : TsapPlaySong;
  xsapRenderBuffer  : TsapRenderBuffer;

  function sapLoadMusicFile(fileName : String ) : TsapMusicstrc;
  function sapRenderBuffer( buffer : PChar; number_of_samples:integer ):integer;
  function sapPlaySong( numOfSong : Integer):integer;

  procedure LoadDLL();
  procedure FreeDLL();

implementation
uses
  SysUtils, Windows;

var
  dll_library : THandle;

function sapLoadMusicFile(fileName : String ) : TsapMusicstrc;
var
 s : PSapMUSICstrc;
begin
  s := xsapLoadMusicFile(PChar(fileName));
  Result := s^;
end;

function sapRenderBuffer( buffer : PChar; number_of_samples:integer ):integer;
begin
 xsapRenderBuffer(buffer,number_of_samples);
end;

function sapPlaySong( numOfSong : Integer):integer;
begin
 xsapPlaySong( numOfSong);
end;

procedure LoadDLL();
begin
  if dll_library <> 0 then FreeDLL();

  dll_library := LoadLibrary(sapDLLNAME);
  if dll_library <> 0 then begin
    xsapLoadMusicFile := GetProcAddress(dll_library,'sapLoadMusicFile');
    xsapRenderBuffer  := GetProcAddress(dll_library,'sapRenderBuffer');
    xsapPlaySong      := GetProcAddress(dll_library,'sapPlaySong');
  end
  else
    raise Exception.Create('Nie mona zaadowa biblioteki DLL: ' + sapDLLNAME);
end;

procedure FreeDLL();
begin
  if dll_library <> 0 then
    FreeLibrary(dll_library);
end;

initialization

finalization
  FreeDLL;
end.
