unit unConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ComCtrls, ExtCtrls, Mask;

type
  TsapMPConfig = class(TForm)
    tvConfig: TTreeView;
    Button1: TButton;
    nb: TNotebook;
    GroupBox1: TGroupBox;
    btnRegister: TButton;
    GroupBox2: TGroupBox;
    cbSilenceDetection: TCheckBox;
    cbJumpToNextSong: TCheckBox;
    UpDown1: TUpDown;
    edJumpAfterTime: TMaskEdit;
    cbJumpDecision: TRadioGroup;
    Label1: TLabel;
    FreqCombo: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure CloseBClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure tvConfigCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure FormPaint(Sender: TObject);
    procedure btnRegisterClick(Sender: TObject);
    procedure tvConfigChange(Sender: TObject; Node: TTreeNode);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  sapMPConfig: TsapMPConfig;

implementation
uses unMain, CommonTypes;
{$R *.dfm}

procedure TsapMPConfig.FormCreate(Sender: TObject);
var rn,ti, t0 : TTreeNode;
begin
 tvConfig.Items.Clear;
 rn := tvConfig.Items.Add(nil,'File types');
 rn.Data := Pointer(0);
 t0 := tvConfig.Items.Add(rn,'Options');
 t0.Data := Pointer(1);
 ti := tvConfig.Items.AddChild(t0,'Display');
 ti.Data := Pointer(2);
 ti := tvConfig.Items.AddChild(t0,'Visualization');
 ti.Data := Pointer(3);
 ti := tvConfig.Items.AddChild(t0,'Sound output');
 ti.Data := Pointer(4);
 t0.Expand(True);
end;

procedure TsapMPConfig.CloseBClick(Sender: TObject);
begin
 Close;
end;

procedure TsapMPConfig.Button1Click(Sender: TObject);
begin
 Close;
end;

procedure TsapMPConfig.tvConfigCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
 AllowCollapse := False;
end;

procedure TsapMPConfig.FormPaint(Sender: TObject);
var
 r:Trect;
begin
  Canvas.Brush.Color := clSilver;
  r := Rect(0,0,Width,Height);
  Canvas.FrameRect(r);
  r := Rect(1,1,Width-1,Height-1);
  Canvas.FrameRect(r);
end;

procedure TsapMPConfig.btnRegisterClick(Sender: TObject);
begin
 unMain.RegisterExtensions;
end;

procedure TsapMPConfig.tvConfigChange(Sender: TObject; Node: TTreeNode);
begin
 nb.PageIndex := Integer(Node.Data);
end;

procedure TsapMPConfig.UpDown1Click(Sender: TObject; Button: TUDBtnType);
const
    btn :array[TUDBtnType] of integer = (1,-1);
var idx, wsp : integer;
    minim,sec : integer;
    tim : TTime;
    s : string;
begin
 wsp   := btn[Button];
 idx   := edJumpAfterTime.SelStart;
 minim := StrToInt(edJumpAfterTime.Text[1]);
 s     := edJumpAfterTime.Text;
 delete(s,1,2);
 sec := StrToInt(s);
 if idx = 0 then  if wsp =1 then minim := minim + Integer(minim<9)
                            else minim := minim - Integer(minim>1);
 if idx in [2,3] then  if wsp =1 then sec := sec + Integer(sec<59)
                            else sec := sec - Integer(sec>1);
 edJumpAfterTime.Text := Format('%d:%.2d',[minim,sec]);
 edJumpAfterTime.SelStart := idx;
 SongTime := ConvertTime(edJumpAfterTime.Text);
end;

end.
