unit unEffectsParams;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Buttons, StdCtrls;

const
 phasetype :array[0..4] of string = ('NEG_180','NEG_90','ZERO','90','180');
type
  Teffect = (efReverb, efChorus, efCompressor, efEcho, efDistortion, efFlanger, efGargle);
  Teffects = set of Teffect;
  
  TsapMP_Effects = class(TForm)
    efPage: TPageControl;
    revTab: TTabSheet;
    chorTab: TTabSheet;
    compTab: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    rev_GainL: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    rev_MixL: TLabel;
    Label3: TLabel;
    rev_TimeL: TLabel;
    Label4: TLabel;
    rev_FreqL: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    chor_WetDryMixL: TLabel;
    chor_DepthL: TLabel;
    chor_FeedbackL: TLabel;
    chor_FrequencyL: TLabel;
    chor_DelayL: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    comp_GainL: TLabel;
    comp_AttackL: TLabel;
    comp_ReleaseL: TLabel;
    procedure efPageChange(Sender: TObject);
    procedure rev_GainChange(Sender: TObject);
    procedure rev_MixChange(Sender: TObject);
    procedure rev_TimeChange(Sender: TObject);
    procedure rev_FreqChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure chor_WetDryMixChange(Sender: TObject);
    procedure chor_DepthChange(Sender: TObject);
    procedure chor_FeedbackChange(Sender: TObject);
    procedure chor_FrequencyChange(Sender: TObject);
    procedure chor_DelayChange(Sender: TObject);
    procedure chor_WaveFormChange(Sender: TObject);
    procedure chor_PhaseChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure comp_GainChange(Sender: TObject);
    procedure comp_AttackChange(Sender: TObject);
    procedure comp_ReleaseChange(Sender: TObject);
    procedure comp_TresholdChange(Sender: TObject);
    procedure comp_RatioChange(Sender: TObject);
    procedure comp_PredelayChange(Sender: TObject);
  private
    { Private declarations }
    effects : Teffects;
    efUpdate : Boolean;
  public
    { Public declarations }
    function GetReverb : Boolean;
    function GetChorus : Boolean;
    function GetComp : Boolean;


    procedure comp_Apply;
    procedure chor_Apply;
    procedure rev_Apply;

    function UpdateParams : Boolean;
  end;

var
  sapMP_Effects: TsapMP_Effects;

implementation
uses unMain, dynamic_bass, unEffects;
{$R *.dfm}
// ef procs

function TsapMP_Effects.UpdateParams : Boolean;
begin
 if efReverb in effects then rev_Apply else GetReverb;
 if efChorus in effects then chor_Apply else GetChorus;
 if efCompressor in effects then comp_Apply else GetComp;

 revTab.Enabled := HFX_REV <> 0;
 chorTab.Enabled := HFX_CHOR <> 0;
 compTab.Enabled := HFX_COMPRES <>0;
 
end;

function TsapMP_Effects.GetReverb : Boolean;
begin
 if HFX_REV <>0 then begin
  Result := BASS_FXGetParameters(HFX_REV,@_FXREVERB);
  if Result then begin
    efUpdate := True;
    Include(Effects,efReverb);
//    rev_gain.Value := Round(_FXREVERB.fInGain);
//    rev_GainL.Caption := Format('%.2d dB',[rev_Gain.Value]);

//    rev_Mix.Value := Round(_FXREVERB.fReverbMix);
//    rev_MixL.Caption := Format('%.2d dB',[rev_Mix.Value]);

//    rev_Time.Value := Round(_FXREVERB.fReverbTime);
//    rev_TimeL.Caption := Format('%.4d ms',[rev_Time.Value]);

//    rev_Freq.Value := Round(1000*_FXREVERB.fHighFreqRTRatio);
//    rev_FreqL.Caption := Format('%.3f ms',[rev_Freq.Value/1000]);

    efUpdate := False;
  end;
 end else
  Result := False;
end;


function TsapMP_Effects.GetComp : Boolean;
begin
 if HFX_COMPRES <>0 then begin
  Result := BASS_FXGetParameters(HFX_COMPRES,@_FXCOMPRESSOR);
  if Result then begin
    efUpdate := true;
    Include(Effects,efCompressor);

{    comp_Gain.Value := Round(_FXCOMPRESSOR.fGain);
    comp_GainL.Caption := Format('%.2d',[comp_Gain.Value]);
    comp_Attack.Value := Round(1000*_FXCOMPRESSOR.fAttack);
    comp_Release.Value := Round(_FXCOMPRESSOR.fRelease);
    comp_Treshold.Value := Round(_FXCOMPRESSOR.fThreshold);
    comp_Ratio.Value := Round(_FXCOMPRESSOR.fRatio);
    comp_Predelay.Value := Round(_FXCOMPRESSOR.fPredelay);
}    
    efUpdate := False;
  end
 end else
  Result := False;
end;

function TsapMP_Effects.GetChorus : Boolean;
begin
 if HFX_CHOR <>0 then begin
  Result := BASS_FXGetParameters(HFX_CHOR,@_FXCHORUS);
  if Result then begin
    efUpdate := true;
    Include(Effects,efChorus);
{    chor_WetDryMix.Value := Round(_FXCHORUS.fWetDryMix);
    chor_DelayL.Caption := Format('%.2d ms',[chor_Delay.Value]);

    chor_Depth.Value := Round(_FXCHORUS.fDepth);
    chor_DepthL.Caption := Format('%.3d %',[chor_Depth.Value]);

    chor_Frequency.Value := Round(_FXCHORUS.fFrequency);
    chor_FeedbackL.Caption := Format('%.2d %',[chor_Feedback.Value]);

    chor_Feedback.Value := Round(_FXCHORUS.fFeedback);
    chor_FrequencyL.Caption := Format('%.2d',[chor_Frequency.Value]);

    chor_Delay.Value := Round(_FXCHORUS.fDelay);
    chor_DelayL.Caption := Format('%.2d ms',[chor_Delay.Value]);

    chor_WaveForm.Value := _FXCHORUS.lWaveform;

    chor_Phase.Value := _FXCHORUS.lPhase;
}
    efUpdate := False;
  end;
 end else
  Result := False;
end;

procedure TsapMP_Effects.efPageChange(Sender: TObject);
begin
 //

  revTab.Enabled := HFX_REV <> 0;
  chorTab.Enabled := HFX_CHOR <> 0;
  compTab.Enabled := HFX_COMPRES <>0;

  case efPage.ActivePageIndex of
   0: GetReverb;
   1: GetChorus;
  end;
 //
end;

procedure TsapMP_Effects.rev_Apply;
begin
 //
 if efUpdate then Exit;
 if HFX_REV <>0 then begin
{  _FXREVERB.fInGain := rev_Gain.Value;
  _FXREVERB.fReverbMix := rev_Mix.Value;
  _FXREVERB.fReverbTime := rev_Time.Value;
  _FXREVERB.fHighFreqRTRatio :=  rev_Freq.Value / 1000;
}
   BASS_FXSetParameters(HFX_REV,@_FXREVERB);
 end;
 //
end;

procedure TsapMP_Effects.rev_GainChange(Sender: TObject);
begin
// rev_GainL.Caption := Format('%.2d dB',[rev_Gain.Value]);
 rev_Apply;
end;

procedure TsapMP_Effects.rev_MixChange(Sender: TObject);
begin
// rev_MixL.Caption := Format('%.2d dB',[rev_Mix.Value]);
 rev_Apply;
end;

procedure TsapMP_Effects.rev_TimeChange(Sender: TObject);
begin
// rev_TimeL.Caption := Format('%.4d ms',[rev_Time.Value]);
 rev_Apply;
end;

procedure TsapMP_Effects.rev_FreqChange(Sender: TObject);
begin
// rev_FreqL.Caption := Format('%.3f ms',[rev_Freq.Value/1000]);
 rev_Apply;
end;

procedure TsapMP_Effects.FormShow(Sender: TObject);
begin
 efPageChange(Self);

 Top  := sapMP_MainWindow.Top  + SapMP_MainWindow.Height;
 if top+Height>Screen.Height then top := Screen.Height-Height-20;

 Left := sapMP_MainWindow.Left;
 if LEft+Width>Screen.Width then Left := Screen.Width-Width-20;

end;

procedure TsapMP_Effects.chor_Apply;
begin
 //
 if efUpdate then Exit;
 if HFX_CHOR <>0 then begin
{    _FXCHORUS.fWetDryMix :=chor_WetDryMix.Value;
    _FXCHORUS.fDepth := chor_Depth.Value;
    _FXCHORUS.fFrequency := chor_Frequency.Value;
    _FXCHORUS.fFeedback := chor_Feedback.Value;
    _FXCHORUS.fDelay := chor_Delay.Value;
    _FXCHORUS.lWaveform := chor_WaveForm.Value;
    _FXCHORUS.lPhase := chor_Phase.Value;
}
  BASS_FXSetParameters(HFX_CHOR,@_FXCHORUS);
 end;
 //
end;

procedure TsapMP_Effects.chor_WetDryMixChange(Sender: TObject);
begin
// chor_WetDryMixL.Caption := Format('%.3d',[chor_WetDryMix.Value]);
 chor_Apply;
end;

procedure TsapMP_Effects.chor_DepthChange(Sender: TObject);
begin
// chor_DepthL.Caption := Format('%.3d %',[chor_Depth.Value]);
 chor_Apply;
end;

procedure TsapMP_Effects.chor_FeedbackChange(Sender: TObject);
begin
// chor_FeedbackL.Caption := Format('%.2d %',[chor_Feedback.Value]);
 chor_Apply;
end;

procedure TsapMP_Effects.chor_FrequencyChange(Sender: TObject);
begin
// chor_FrequencyL.Caption := Format('%.2d',[chor_Frequency.Value]);
 chor_Apply;
end;

procedure TsapMP_Effects.chor_DelayChange(Sender: TObject);
begin
// chor_DelayL.Caption := Format('%.2d ms',[chor_Delay.Value]);
 chor_Apply;
end;

procedure TsapMP_Effects.chor_WaveFormChange(Sender: TObject);
begin
 chor_Apply;
end;

procedure TsapMP_Effects.chor_PhaseChange(Sender: TObject);
begin
 chor_Apply;
end;


procedure TsapMP_Effects.comp_Apply;
begin
 if efUpdate then Exit;
 if HFX_COMPRES <>0 then begin
{  _FXCOMPRESSOR.fGain := Comp_Gain.Value;
  _FXCOMPRESSOR.fAttack := comp_Attack.Value / 1000;
  _FXCOMPRESSOR.fRelease := comp_Release.Value;
  _FXCOMPRESSOR.fThreshold := comp_Treshold.Value;
  _FXCOMPRESSOR.fRatio := comp_Ratio.Value;
  _FXCOMPRESSOR.fPredelay := comp_Predelay.Value;
}
  BASS_FXSetParameters(HFX_COMPRES,@_FXCOMPRESSOR);
 end;
end;

procedure TsapMP_Effects.FormCreate(Sender: TObject);
begin
// SpeedButton1.Align := alRight;
 effects := [];
end;

procedure TsapMP_Effects.FormPaint(Sender: TObject);
var
 r : trect;
begin
  Canvas.Brush.Color := clGray;
  r := Rect(0,0,Width,Height);
  Canvas.FrameRect(r);
  r := Rect(1,1,Width-1,Height-1);
  Canvas.FrameRect(r);
end;


procedure TsapMP_Effects.SpeedButton1Click(Sender: TObject);
begin
 Close;
end;

procedure TsapMP_Effects.comp_GainChange(Sender: TObject);
begin
// comp_GainL.Caption := Format('%.2d dB',[comp_Gain.Value]);
 comp_Apply;
end;

procedure TsapMP_Effects.comp_AttackChange(Sender: TObject);
begin
// comp_AttackL.Caption := Format('%.3f ms',[comp_Attack.Value/1000]);
 comp_Apply;
end;

procedure TsapMP_Effects.comp_ReleaseChange(Sender: TObject);
begin
// comp_ReleaseL.Caption := Format('%.3d ms',[comp_Release.Value]);
 comp_Apply;
end;

procedure TsapMP_Effects.comp_TresholdChange(Sender: TObject);
begin
 comp_Apply;

end;

procedure TsapMP_Effects.comp_RatioChange(Sender: TObject);
begin
 comp_Apply;

end;

procedure TsapMP_Effects.comp_PredelayChange(Sender: TObject);
begin
 comp_Apply;

end;

end.
