unit unInfo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, CommonTypes, StdCtrls;

type
  TsapMP_Info = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    sapMPDockType : TsapMPDockType;
   function sapMPDocked : Boolean;
  public
    { Public declarations }
   procedure SetWPos(x,y : integer);
   procedure SetSapMPDocked(DockType : TsapMPDockType);
   procedure UpdateInfo;
  end;

var
  sapMP_Info: TsapMP_Info;

implementation

uses unMain;

{$R *.dfm}

function TsapMP_Info.sapMPDocked : Boolean;
begin
 Result := sapMPDockType<>smdockFree;
end;


procedure TsapMP_Info.FormCreate(Sender: TObject);
begin
 SetSapMPDocked(smdockFree);
end;

procedure TsapMP_Info.FormPaint(Sender: TObject);
var
 r : TRect;
begin
 //
  Canvas.Brush.Color := clSilver;
  r := Rect(0,0,Width,Height);
  Canvas.FrameRect(r);
  r := Rect(1,1,Width-1,Height-1);
  Canvas.FrameRect(r);
 //
end;

procedure TsapMP_Info.FormShow(Sender: TObject);
begin
{ if sapMPDocked then begin
  SetWPos(0,0);
 end
 else
 begin
   Left := sapMP_MainWindow.Left+sapMP_MainWindow.Width;
   Top  := sapMP_MainWindow.Top;
   SetSapMPDocked(smdockLeft);
 end;
}
end;

procedure TsapMP_Info.SpeedButton1Click(Sender: TObject);
begin
 Close;
end;

procedure TsapMP_Info.SetSapMPDocked(DockType : TsapMPDockType);
begin
 sapMPDockType := DockType;
end;

procedure TsapMP_Info.SetWPos(x,y : integer);
begin
 if not sapMPDocked then exit;
 case sapMPDockType of
  smdockLeft : begin
   Left := {sapMP_MainWindow.Left+}x+sapMP_MainWindow.Width;
   Top  := {sapMP_MainWindow.Top+}y;
//                   Left := x+sapMP_MainWindow.Width;
//                   Top  := y; //sapMP_MainWindow.Top;
               end;
 end;
end;

procedure TsapMP_Info.UpdateInfo;
begin
 Label1.Caption := 'Author : '+SongInfo.Author;
 Label2.Caption := 'Title  : '+SongInfo.Title;
 Label3.Caption := 'Date   : '+SongInfo.Date;
 if SongInfo.Stereo then Label4.Caption :='Stero'
                    else Label4.Caption :='Mono';
end;

end.
