unit unPlayList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, StdCtrls, ShellApi, CommonTypes,
  ComCtrls, Menus, ActnList, JvComponent, JvTransBtn, JvListBox, JvCtrls,
  JvPlaylist, AJBFormCaption;

type
  TsapMP_PlayList = class(TForm)
    Panel1: TPanel;
    plMenu: TPopupMenu;
    ActionList1: TActionList;
    acPlayItem: TAction;
    acRemoveItem: TAction;
    acCropFiles: TAction;
    Playitem1: TMenuItem;
    N1: TMenuItem;
    Removeitems1: TMenuItem;
    Cropfiles1: TMenuItem;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    RemMenu: TPopupMenu;
    acRemoveAll: TAction;
    acRemAllDead: TAction;
    acRemovePhys: TAction;
    RemoveallDeadfiles1: TMenuItem;
    Physicalyremoveselectedfiles1: TMenuItem;
    N2: TMenuItem;
    Removeall1: TMenuItem;
    Cropfiles2: TMenuItem;
    SpeedButton4: TSpeedButton;
    SaveDialog1: TSaveDialog;
    Plist: TJvPlaylist;
    Panel2: TPanel;
    CloseB: TJvTransparentButton;
    CaptionBar: TPanel;
    OpenDialog1: TOpenDialog;
    AJBFormCaption1: TAJBFormCaption;
    SpeedButton1: TSpeedButton;
    MiscMenu: TPopupMenu;
    acSortByName: TAction;
    acSortByPath: TAction;
    acRandomOrder: TAction;
    Sortbyname1: TMenuItem;
    SortbyPath1: TMenuItem;
    RandomOrder1: TMenuItem;
    N3: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acPlayItemExecute(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure acRemoveAllExecute(Sender: TObject);
    procedure acRemoveItemExecute(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure CloseBClick(Sender: TObject);
    procedure PlistDblClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure acSortByNameExecute(Sender: TObject);
    procedure acSortByPathExecute(Sender: TObject);
    procedure acRandomOrderExecute(Sender: TObject);
    procedure acRemAllDeadExecute(Sender: TObject);
    procedure acCropFilesExecute(Sender: TObject);
  private
    { Private declarations }
   procedure WndProc(var M:TMessage); override;
   procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  public
    { Public declarations }
   procedure AddRecursiveDirectory(FileName : String);
  end;

var
  sapMP_PlayList: TsapMP_PlayList;
  oldv : integer;
implementation

uses unMain, Masks;

{$R *.dfm}

procedure TsapMP_PlayList.AddRecursiveDirectory;
var sr : TSearchRec;
    FileAttrs: Integer;
begin

  FileAttrs := faDirectory+ faArchive;
  if FindFirst(FileName+'\*.*', FileAttrs, sr) = 0 then
  begin
    repeat
      if (sr.Attr and FileAttrs) = sr.Attr then
      begin
          if MatchesMask(sr.Name,'*.sap') then
            begin
              CaptionBar.Caption := sr.Name;
              pList.Items.Add(FileName+'\'+sr.Name);
              Application.ProcessMessages;
            end;
          if MatchesMask(sr.Name,'*.pla') then pList.LoadPlaylist(FileName+'\'+sr.Name);
          if (((sr.Attr and faDirectory)=faDirectory) and (sr.Name<>'.') and (sr.Name<>'..'))
              then AddRecursiveDirectory(FileName+'\'+sr.Name);
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
   end; 
end;


procedure TsapMP_PlayList.WndProc;
var p: TPoint;
begin
  inherited;
  if (M.Msg = WM_NCHITTEST) then
   with TWMNCHitTest(M) do begin
     p := ScreenToClient(Point(xPos,yPos));
     if (p.x <5) and (p.y <6) then Result := HTTOPLEFT else
     if (p.x > Width -6) and (p.Y <5) then Result := HTTOPRIGHT else
     if (p.x <5) and (p.y >Height -6) then Result := HTBOTTOMLEFT else
     if (p.x > Width-6)  and (p.Y > Height-6) then Result := HTBOTTOMRIGHT else
     if (p.x < 5)        then Result := HTLEFT   else
     if (p.y < 5)        then Result := HTTOP    else
     if (p.x > Width-6)  then Result := HTRIGHT  else
     if (p.y > Height-6) then Result := HTBOTTOM;
   end;
end;

procedure TsapMP_PlayList.WMDropFiles(var Msg: TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
  _Files,
       i : Integer;
  fn : string;
  FileAttrib : DWord;
begin
  try
    _Files := DragQueryFile(Msg.Drop, $FFFFFFFF, CFileName, MAX_PATH);
    if _Files > 0 then begin
      for i := 0 to _Files-1 do begin
         FillChar(CFileName,MAX_PATH,0);
         DragQueryFile(Msg.Drop, i , CFileName, MAX_PATH);
         FileAttrib := GetFileAttributes(CFileName);
// FILE_ATTRIBUTE_DIRECTORY
         if (FileAttrib and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY) then
          begin
            pList.Visible := False;
            AddRecursiveDirectory(CFILENAME);
            pList.Visible := True;
            CaptionBar.Caption := 'Play list';
          end
         else
         if (FileAttrib and FILE_ATTRIBUTE_NORMAL = FILE_ATTRIBUTE_NORMAL ) or (FileAttrib and FILE_ATTRIBUTE_ARCHIVE = FILE_ATTRIBUTE_ARCHIVE)
         or (FileAttrib and FILE_ATTRIBUTE_READONLY = FILE_ATTRIBUTE_READONLY) then
         begin
          if MatchesMask(CFileName,'*.sap') then pList.Items.Add(CFileName);
          if MatchesMask(CFileName,'*.pla') then pList.LoadPlaylist(CFileName);
         end;
      end;
     Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop);
//    Slider1.MaxValue := pList.ScrollWidth;
//    Slider1.Value    := pList.ScrollWidth;
  end;
end;

procedure TsapMP_PlayList.FormCreate(Sender: TObject);
begin
 DragAcceptFiles(sapMP_PlayList.Handle,True);
end;

procedure TsapMP_PlayList.FormDestroy(Sender: TObject);
begin
  pList.SavePlaylist('sapMP.pla');
end;

procedure TsapMP_PlayList.acPlayItemExecute(Sender: TObject);
var fn : string;
begin
   fn := pList.Items[pList.ItemIndex];
   pList.Invalidate;
   if fn<>'' then begin
     sapMP_MainWindow.LoadSAPMusic(fn);
     sapMP_MainWindow.StartBClick(nil);
   end;  
end;

procedure TsapMP_PlayList.SpeedButton3Click(Sender: TObject);
var
 TP : TPoint;
begin
 GetCursorPos(TP);
 RemMenu.Popup(Tp.X,TP.Y);
end;

procedure TsapMP_PlayList.SpeedButton4Click(Sender: TObject);
begin
 SaveDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   if SaveDialog1.Execute then pList.SavePlaylist(SaveDialog1.FileName);
end;

procedure TsapMP_PlayList.acRemoveAllExecute(Sender: TObject);
begin
 pList.Clear;
end;

procedure TsapMP_PlayList.acRemoveItemExecute(Sender: TObject);
begin
 pList.Items.Delete(pList.ItemIndex);
end;

procedure TsapMP_PlayList.SpeedButton2Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
    pList.AddItems(OpenDialog1.Files);
end;

procedure TsapMP_PlayList.CloseBClick(Sender: TObject);
begin
 Close;
end;

procedure TsapMP_PlayList.PlistDblClick(Sender: TObject);
begin
 acPlayItem.Execute;
end;

procedure TsapMP_PlayList.SpeedButton1Click(Sender: TObject);
var
 TP : TPoint;
begin
 GetCursorPos(TP);
 MiscMenu.Popup(Tp.X,TP.Y);
end;

procedure TsapMP_PlayList.acSortByNameExecute(Sender: TObject);
begin
 PList.SortBySongName;
end;

procedure TsapMP_PlayList.acSortByPathExecute(Sender: TObject);
begin
 PList.SortByPath;
end;

procedure TsapMP_PlayList.acRandomOrderExecute(Sender: TObject);
begin
 PList.RandomOrder;
 pList.ItemIndex := pList.Items.IndexOf(SongInfo.FileName);
end;

procedure TsapMP_PlayList.acRemAllDeadExecute(Sender: TObject);
begin
 PList.DeleteDeadFiles
end;

procedure TsapMP_PlayList.acCropFilesExecute(Sender: TObject);
begin
 pList.DeleteAllButSelected;
end;

end.
